package com.dtai.gwt;

import java.net.*;
import java.io.*;

/**
 * Our dummy implementation of URLConnection used to open
 * up a local file when called upon with a given URL of ANY protocol type.  This
 * allows the applet to easily use the "getInputStream()" function.
 *
 * @version	1.1
 * @author	DTAI, Incorporated
 */
class AmFileURLConnection extends URLConnection {

    boolean connected = false;
    InputStream instream;

    /**
     * Constructor for the AmURLConnection
     * @param url
     */
    protected AmFileURLConnection( URL url ) {
        super( url );
    }

    /**
     * Open the local file
     */
    public void connect() throws IOException {
        if ( ! connected ) {
            String filename = url.getFile();
            if ( filename.charAt(1) == '|' ) {
                StringBuffer buf = new StringBuffer( filename );
                buf.setCharAt( 1, ':' );
                filename = buf.toString();
            }
            else if ( filename.charAt(2) == '|' ) {
                StringBuffer buf = new StringBuffer( filename );
                buf.setCharAt( 2, ':' );
                filename = buf.toString();
            }
            instream = new FileInputStream( filename );
        }
    }

    /**
     * Return the open stream to the local file (open if necessary).
	 *
	 * @return InputStream		the open stream
     */
    public InputStream getInputStream() throws IOException {
        if ( ! connected ) {
            connect();
        }
        if ( instream == null ) {
            throw new IOException();
        }
        return instream;
    }

    /**
     * Return the content type, if known, or null.
	 *
	 * @return the MIME content type, either "image/jpg" or "image/gif"
     */
    public String getContentType() {
        if ( url.getFile().toLowerCase().endsWith(".gif") ) {
            return "image/gif";
        }
        else if ( url.getFile().toLowerCase().endsWith(".jpg") ) {
            return "image/jpg";
        }
        else {
            return null;
        }
    }
}

