package com.dtai.gwt;

import com.dtai.gui.*;
import java11.awt.event.*;
import java11.awt.*;
import java.awt.*;
//import java.awt.event.*;
/**
 * TreeControl
 * @version 1.1
 * @author DTAI, Incorporated
 */
class TreeControl extends CanvasGadget {

    private TreeNode node;

    public TreeControl(TreeNode node) {
        this.node = node;
    }

    public Dimension getPreferredSize() {
        pref_width = TreePanel.CONTROL_WIDTH;
        pref_height = TreePanel.CONTROL_WIDTH;
        return new Dimension(pref_width, pref_height);
    }

    /**
     * clear
     * @param g - TBD
     */
    public void clear(GadgetGraphics g) {
        g.setColor(getNormalForeground(g));
    }

    private static final int mid_width = 4;
    private static final int left = 2;
    private static final int right = 6;

    /**
     * paint
     * @param g - TBD
     */
    public void paint(GadgetGraphics g) {
        int mid_height = (height / 2);
        int top = mid_height - 2;
        int bottom = mid_height + 2;

        g.drawLine( left, mid_height, right, mid_height );
        if (!node.isExpanded()) {
            g.drawLine( mid_width, top, mid_width, bottom );
        }
        g.drawRect(left-2, top-2, TreePanel.CONTROL_WIDTH-1, TreePanel.CONTROL_WIDTH-1);
    }

    /**
     * getBottom
     * @return int
     */
    public int getBottom() {
        return (height / 2) + 4;
    }

    /**
     * processMouseEvent
     * @param mouse the MouseEvent
     */
    public void processMouseEvent( MouseEvent e ) {
        if (e.getID() == MouseEvent.MOUSE_PRESSED) {
            node.setExpanded(!node.isExpanded());
            TreePanel panel = node.getTreePanel();
            if (panel != null) {
                panel.select(node,e);
            }
            repaint();
      	}
        e.consume();
        super.processMouseEvent( e );
    }
}
