package org.signwriting;

import java.io.RandomAccessFile;
import java.io.IOException;

/**
 * reads the symbol file
 */
public class DictionaryFile extends RandomAccessFile {

    public static final int RECSIZE = 44;

    String filename;

    /**
     * constructor, takes a file name, opens it and reads it
     */
    public DictionaryFile(String filename) throws IOException {
        super(filename,"r");
        this.filename = filename;
    }

    public DictionaryRecord getRecord(int recnum) {
        try {
            seek((recnum-1)*RECSIZE);
            return new DictionaryRecord(this);
        } catch (IOException ioe) {
            com.dtai.util.ShowUser.error(ioe,"File error reading dictionary record");
        }
        return null;
    }
}
